/* olainterface.cpp
   Santi Noreña 2013
   It includes two classes:
   olaWorker is the threading class that reads raw DMX from ola daemon and save it into a buffer ordered in layers
   olaInterface controls olaWorker and translates DMX values received from olaWorker into orders to RenderingManager and Source
*/

#include "olainterface.h"

olaInterface::olaInterface()
{
    qDebug() << tr("olaInterface|") << "Starting";
    m_thread = NULL;
    m_thread = new QThread;
    Q_CHECK_PTR(m_thread);
    worker = new olaWorker();
    Q_CHECK_PTR(worker);
    connect (worker, SIGNAL(dmx(int,int,int)), this, SLOT(dmx(int,int,int)), Qt::QueuedConnection); // The DMX values.
    worker->moveToThread(m_thread);
    connect(m_thread, SIGNAL(started()), worker, SLOT(olastart()));
    connect(m_thread, SIGNAL(finished()), m_thread, SLOT(deleteLater()));
    m_thread->start();
}

olaInterface::~olaInterface()
{
    close();
}

// Close olaWorker and finish the thread
void olaInterface::close()
{
    worker->blockSignals(true);
    worker->olastop();
    delete worker;
}

////////////////////////////////////////////////////////////
//
// Parse new DMX
//
////////////////////////////////////////////////////////////

//New dmx. Connected with signal newdmx from olaInterface->Worker
void olaInterface::dmx(int layer, int channel, int value)
{

}



