/* olainterface.h
   Santi Noreña 2013
   It includes two classes:
   olaWorker is the threading class that reads raw DMX from ola daemon
   olaInterface controls olaWorker and translates DMX values received from olaWorker into orders to RenderingManager and Source
*/
#ifndef OLAINTERFACE_H
#define OLAINTERFACE_H

//#define DMX_SOURCETYPE 7

#define LAYER_CHANNELS 15 // The numer of control channels per video layer
#define MAX_SOURCE_DMX 8 // Number of maximum Sources controlled by DMX. It should be equal to MAX_SOURCE_COUNT

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <QObject>

#include <QDebug>
#include <QXmlStreamReader>
#include <QFile>
#include <QMessageBox>
#include <QProcess>

// The OLA Library
#include <ola/OlaClientWrapper.h>
#include <ola/OlaCallbackClient.h>
//#include <ola/OlaClient.h>


#include "libremediaserver.h"

using namespace ola;

class olaInterface : public QObject
{
    Q_OBJECT

public:
    explicit olaInterface();
    virtual ~olaInterface();

    void open(); // Starts the thread and open the connection with olad
    void close(); // Close the connection with olad

    olaWorker *worker; // The thread of connection with ola.

protected:

    QThread *m_thread; // The thread for olaWorker

private:

    void readDataFromXML(); // Read the DMX configuration from the file dmx.xml

public slots:

    void dmx(int layer, int channel, int value); // Connected with signal dmx from olaWorker. This is the horsepower of all this. Converts DMX orders
                                                 // into orders to RenderingManager and Source. Mantains updated the videolayer struct.
signals:

};


#endif // OLAINTERFACE_H

